package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.Registry;
import com.sa.ibiz.demo.demo.service.RegistryService;
import com.sa.ibiz.demo.demo.service.dto.RegistrySearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/registry")
public class RegistryResource
{
	@Autowired
	private RegistryService service;


	@PostMapping(value = "/getDraft")
	public ResponseEntity<Registry> getDraft(@Validated @RequestBody Registry data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("注册表[getDraft]操作发生错误","Registry","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<Registry> get(@Validated @PathVariable String id){
		Registry data=new Registry();
		data.setRegistryid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("注册表[get]操作发生错误","Registry",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<Registry> update(@Validated @RequestBody Registry data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("注册表[update]操作发生错误","Registry",data.getRegistryid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<Registry> checkKey(@Validated @RequestBody Registry data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("注册表[checkKey]操作发生错误","Registry",data.getRegistryid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<Registry> create(@Validated @RequestBody Registry data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("注册表[create]操作发生错误","Registry",data.getRegistryid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<Registry> remove(@Validated @RequestBody Registry data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("注册表[remove]操作发生错误","Registry",data.getRegistryid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<Registry>> searchDefaultPage(@Validated @RequestBody RegistrySearchFilter filter){
		Page<Registry> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<Registry>> listDefault(@Validated @RequestBody RegistrySearchFilter filter){
		List<Registry> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
